###############################################################################
#
# Bash remediation role for profile C2S-docker
# Profile Title:  C2S for Docker
# Profile Description:
# This profile demonstrates compliance against the
# U.S. Government Commercial Cloud Services (C2S) baseline.
# 
# This baseline was inspired by the Center for Internet Security
# (CIS) Docker Community Edition Benchmark, v1.1.0 - 07-06-2017.
# 
# For the SCAP Security Guide project to remain in compliance with
# CIS' terms and conditions, specifically Restrictions(8), note
# there is no representation or claim that the C2S profile will
# ensure a system is in compliance or consistency with the CIS
# baseline.
# 
#
# Benchmark ID:  RHEL-7
# Benchmark Version:  0.1.38
#
# XCCDF Version:  1.1
#
# This file was generated by OpenSCAP 1.2.16 using:
# 	$ oscap xccdf generate fix --profile C2S-docker --template urn:xccdf:fix:script:sh sds.xml 
#
# This script is generated from an OpenSCAP profile without preliminary evaluation.
# It attempts to fix every selected rule, even if the system is already compliant.
#
# How to apply this remediation role:
# $ sudo ./remediation-role.sh
#
###############################################################################

###############################################################################
# BEGIN fix (1 / 1) for 'security_patches_up_to_date'
###############################################################################
(>&2 echo "Remediating rule 1/1: 'security_patches_up_to_date'")
yum -y update
# END fix for 'security_patches_up_to_date'

