###############################################################################
#
# Bash remediation role for profile standard
# Profile Title:  Standard System Security Profile
# Profile Description:
# This profile contains rules to ensure standard security baseline of a Fedora system.
# Regardless of your system's workload all of these checks should pass.
#
# Benchmark ID:  FEDORA
# Benchmark Version:  0.1.38
#
# XCCDF Version:  1.1
#
# This file was generated by OpenSCAP 1.2.16 using:
# 	$ oscap xccdf generate fix --profile standard --template urn:xccdf:fix:script:sh sds.xml 
#
# This script is generated from an OpenSCAP profile without preliminary evaluation.
# It attempts to fix every selected rule, even if the system is already compliant.
#
# How to apply this remediation role:
# $ sudo ./remediation-role.sh
#
###############################################################################

###############################################################################
# BEGIN fix (1 / 9) for 'ensure_gpgcheck_globally_activated'
###############################################################################
(>&2 echo "Remediating rule 1/9: 'ensure_gpgcheck_globally_activated'")
# FIX FOR THIS RULE IS MISSING
# END fix for 'ensure_gpgcheck_globally_activated'

###############################################################################
# BEGIN fix (2 / 9) for 'rpm_verify_permissions'
###############################################################################
(>&2 echo "Remediating rule 2/9: 'rpm_verify_permissions'")
# FIX FOR THIS RULE IS MISSING
# END fix for 'rpm_verify_permissions'

###############################################################################
# BEGIN fix (3 / 9) for 'rpm_verify_hashes'
###############################################################################
(>&2 echo "Remediating rule 3/9: 'rpm_verify_hashes'")
# FIX FOR THIS RULE IS MISSING
# END fix for 'rpm_verify_hashes'

###############################################################################
# BEGIN fix (4 / 9) for 'file_permissions_library_dirs'
###############################################################################
(>&2 echo "Remediating rule 4/9: 'file_permissions_library_dirs'")
# FIX FOR THIS RULE IS MISSING
# END fix for 'file_permissions_library_dirs'

###############################################################################
# BEGIN fix (5 / 9) for 'file_ownership_library_dirs'
###############################################################################
(>&2 echo "Remediating rule 5/9: 'file_ownership_library_dirs'")
for LIBDIR in /usr/lib /usr/lib64 /lib /lib64
do
  if [ -d $LIBDIR ]
  then
    find -L $LIBDIR \! -user root -exec chown root {} \; 
  fi
done
# END fix for 'file_ownership_library_dirs'

###############################################################################
# BEGIN fix (6 / 9) for 'file_permissions_binary_dirs'
###############################################################################
(>&2 echo "Remediating rule 6/9: 'file_permissions_binary_dirs'")
# FIX FOR THIS RULE IS MISSING
# END fix for 'file_permissions_binary_dirs'

###############################################################################
# BEGIN fix (7 / 9) for 'file_ownership_binary_dirs'
###############################################################################
(>&2 echo "Remediating rule 7/9: 'file_ownership_binary_dirs'")
# FIX FOR THIS RULE IS MISSING
# END fix for 'file_ownership_binary_dirs'

###############################################################################
# BEGIN fix (8 / 9) for 'no_empty_passwords'
###############################################################################
(>&2 echo "Remediating rule 8/9: 'no_empty_passwords'")
sed --follow-symlinks -i 's/\<nullok\>//g' /etc/pam.d/system-auth
sed --follow-symlinks -i 's/\<nullok\>//g' /etc/pam.d/password-auth
# END fix for 'no_empty_passwords'

###############################################################################
# BEGIN fix (9 / 9) for 'accounts_root_path_dirs_no_write'
###############################################################################
(>&2 echo "Remediating rule 9/9: 'accounts_root_path_dirs_no_write'")
# FIX FOR THIS RULE IS MISSING
# END fix for 'accounts_root_path_dirs_no_write'

