###############################################################################
#
# Bash remediation role for profile common
# Profile Title:  Common Profile for Webmin system administration tool
# Profile Description:
# 
#
# Benchmark ID:  WEBMIN
# Benchmark Version:  0.1.38
#
# XCCDF Version:  1.1
#
# This file was generated by OpenSCAP 1.2.16 using:
# 	$ oscap xccdf generate fix --profile common --template urn:xccdf:fix:script:sh sds.xml 
#
# This script is generated from an OpenSCAP profile without preliminary evaluation.
# It attempts to fix every selected rule, even if the system is already compliant.
#
# How to apply this remediation role:
# $ sudo ./remediation-role.sh
#
###############################################################################

###############################################################################
# BEGIN fix (1 / 28) for 'accounts_use_pam'
###############################################################################
(>&2 echo "Remediating rule 1/28: 'accounts_use_pam'")
if [ "$(grep -c '^no_pam=' /etc/webmin/miniserv.conf)" = "0" ]; then
	echo "no_pam=0" >> /etc/webmin/miniserv.conf
else
	sed -i "s/^no_pam=.*/no_pam=0/" /etc/webmin/miniserv.conf
fi
# END fix for 'accounts_use_pam'

###############################################################################
# BEGIN fix (2 / 28) for 'accounts_passwd_cmd'
###############################################################################
(>&2 echo "Remediating rule 2/28: 'accounts_passwd_cmd'")
if [ "$(grep -c '^passwd_cmd=' /etc/webmin/config)" = "0" ]; then
	echo "passwd_cmd=/usr/bin/passwd" >> /etc/webmin/config
else
	sed -i "s/^passwd_cmd=.*/passwd_cmd=\/usr\/bin\/passwd/" /etc/webmin/config
fi
# END fix for 'accounts_passwd_cmd'

###############################################################################
# BEGIN fix (3 / 28) for 'accounts_passwd_mode'
###############################################################################
(>&2 echo "Remediating rule 3/28: 'accounts_passwd_mode'")
if [ "$(grep -c '^passwd_mode=' /etc/webmin/miniserv.conf)" = "0" ]; then
	echo "passwd_mode=2" >> /etc/webmin/miniserv.conf
else
	sed -i "s/^passwd_mode=.*/passwd_mode=2/" /etc/webmin/miniserv.conf
fi
# END fix for 'accounts_passwd_mode'

###############################################################################
# BEGIN fix (4 / 28) for 'sessions_login_banner'
###############################################################################
(>&2 echo "Remediating rule 4/28: 'sessions_login_banner'")

var_webmin_sessions_login_banner_text="You[\s\n]+are[\s\n]+accessing[\s\n]+a[\s\n]+U.S.[\s\n]+Government[\s\n]+\(USG\)[\s\n]+Information[\s\n]+System[\s\n]+\(IS\)[\s\n]+that[\s\n]+is[\s\n]+provided[\s\n]+for[\s\n]+USG-authorized[\s\n]+use[\s\n]+only.[\s\n]*By[\s\n]+using[\s\n]+this[\s\n]+IS[\s\n]+\(which[\s\n]+includes[\s\n]+any[\s\n]+device[\s\n]+attached[\s\n]+to[\s\n]+this[\s\n]+IS\),[\s\n]+you[\s\n]+consent[\s\n]+to[\s\n]+the[\s\n]+following[\s\n]+conditions\:[\s\n]*-[\s\n]*The[\s\n]+USG[\s\n]+routinely[\s\n]+intercepts[\s\n]+and[\s\n]+monitors[\s\n]+communications[\s\n]+on[\s\n]+this[\s\n]+IS[\s\n]+for[\s\n]+purposes[\s\n]+including,[\s\n]+but[\s\n]+not[\s\n]+limited[\s\n]+to,[\s\n]+penetration[\s\n]+testing,[\s\n]+COMSEC[\s\n]+monitoring,[\s\n]+network[\s\n]+operations[\s\n]+and[\s\n]+defense,[\s\n]+personnel[\s\n]+misconduct[\s\n]+\(PM\),[\s\n]+law[\s\n]+enforcement[\s\n]+\(LE\),[\s\n]+and[\s\n]+counterintelligence[\s\n]+\(CI\)[\s\n]+investigations.[\s\n]*-[\s\n]*At[\s\n]+any[\s\n]+time,[\s\n]+the[\s\n]+USG[\s\n]+may[\s\n]+inspect[\s\n]+and[\s\n]+seize[\s\n]+data[\s\n]+stored[\s\n]+on[\s\n]+this[\s\n]+IS.[\s\n]*-[\s\n]*Communications[\s\n]+using,[\s\n]+or[\s\n]+data[\s\n]+stored[\s\n]+on,[\s\n]+this[\s\n]+IS[\s\n]+are[\s\n]+not[\s\n]+private,[\s\n]+are[\s\n]+subject[\s\n]+to[\s\n]+routine[\s\n]+monitoring,[\s\n]+interception,[\s\n]+and[\s\n]+search,[\s\n]+and[\s\n]+may[\s\n]+be[\s\n]+disclosed[\s\n]+or[\s\n]+used[\s\n]+for[\s\n]+any[\s\n]+USG-authorized[\s\n]+purpose.[\s\n]*-[\s\n]*This[\s\n]+IS[\s\n]+includes[\s\n]+security[\s\n]+measures[\s\n]+\(e.g.,[\s\n]+authentication[\s\n]+and[\s\n]+access[\s\n]+controls\)[\s\n]+to[\s\n]+protect[\s\n]+USG[\s\n]+interests[\s\n]+--[\s\n]+not[\s\n]+for[\s\n]+your[\s\n]+personal[\s\n]+benefit[\s\n]+or[\s\n]+privacy.[\s\n]*-[\s\n]*Notwithstanding[\s\n]+the[\s\n]+above,[\s\n]+using[\s\n]+this[\s\n]+IS[\s\n]+does[\s\n]+not[\s\n]+constitute[\s\n]+consent[\s\n]+to[\s\n]+PM,[\s\n]+LE[\s\n]+or[\s\n]+CI[\s\n]+investigative[\s\n]+searching[\s\n]+or[\s\n]+monitoring[\s\n]+of[\s\n]+the[\s\n]+content[\s\n]+of[\s\n]+privileged[\s\n]+communications,[\s\n]+or[\s\n]+work[\s\n]+product,[\s\n]+related[\s\n]+to[\s\n]+personal[\s\n]+representation[\s\n]+or[\s\n]+services[\s\n]+by[\s\n]+attorneys,[\s\n]+psychotherapists,[\s\n]+or[\s\n]+clergy,[\s\n]+and[\s\n]+their[\s\n]+assistants.[\s\n]+Such[\s\n]+communications[\s\n]+and[\s\n]+work[\s\n]+product[\s\n]+are[\s\n]+private[\s\n]+and[\s\n]+confidential.[\s\n]+See[\s\n]+User[\s\n]+Agreement[\s\n]+for[\s\n]+details."

if [ "$(grep -c '^loginbanner=' /etc/webmin/config)" = "0" ]; then
	echo loginbanner=/etc/webmin/login_banner >> /etc/webmin/config
else
	sed -i 's/^loginbanner=.*/loginbanner=\/etc\/webmin\/login_banner/' /etc/webmin/config
fi
echo $var_webmin_sessions_login_banner_text | sed -e 's/\[\\s\\n\][+|*]/ /g' -e 's/\&amp;/\&/g' -e 's/\\//g' -e 's/ - /\n- /g' >/etc/webmin/login_banner
echo "<a href='LOGINURL'>Click here to login</a>" >> /etc/webmin/login_banner
# END fix for 'sessions_login_banner'

###############################################################################
# BEGIN fix (5 / 28) for 'sessions_port'
###############################################################################
(>&2 echo "Remediating rule 5/28: 'sessions_port'")

var_webmin_sessions_port="15000"

if [ "$(grep -c '^port=' /etc/webmin/miniserv.conf)" = "0" ]; then
	echo port=$var_webmin_sessions_port >> /etc/webmin/miniserv.conf
else
	sed -i "s/^port=.*/port=$var_webmin_sessions_port/" /etc/webmin/miniserv.conf
fi
if [ "$(grep -c '^listen=' /etc/webmin/miniserv.conf)" = "0" ]; then
	echo listen=$var_webmin_sessions_port >> /etc/webmin/miniserv.conf
else
	sed -i "s/^listen=.*/listen=$var_webmin_sessions_port/" /etc/webmin/miniserv.conf
fi
# END fix for 'sessions_port'

###############################################################################
# BEGIN fix (6 / 28) for 'sessions_save_password'
###############################################################################
(>&2 echo "Remediating rule 6/28: 'sessions_save_password'")
if [ "$(grep -c '^noremember=' /etc/webmin/config)" = "0" ]; then
	echo "noremember=1" >> /etc/webmin/config
else
	sed -i "s/^noremember=.*/noremember=1/" /etc/webmin/config
fi
# END fix for 'sessions_save_password'

###############################################################################
# BEGIN fix (7 / 28) for 'sessions_ssl_cipher'
###############################################################################
(>&2 echo "Remediating rule 7/28: 'sessions_ssl_cipher'")
if [ "$(grep -c no_ssl3 /usr/libexec/webmin/miniserv.pl)" = "0" ]; then
	if [ "$(grep -c '^ssl_cipher_list=' /etc/webmin/miniserv.conf)" = "0" ]; then
		echo 'ssl_cipher_list=ECDHE-RSA-AES256-SHA384:AES256-SHA256:RC4:HIGH:+TLSv1.2:+TLSv1:!MD5:!SSLv2:!SSLv3:!ADH:!aNULL:!eNULL:!NULL:!DH:!EDH:!AESGCM' >> /etc/webmin/miniserv.conf
	else
		sed -i 's/^ssl_cipher_list=.*/ssl_cipher_list=ECDHE-RSA-AES256-SHA384:AES256-SHA256:RC4:HIGH:+TLSv1.2:+TLSv1:!MD5:!SSLv2:!SSLv3:!ADH:!aNULL:!eNULL:!NULL:!DH:!EDH:!AESGCM/' /etc/webmin/miniserv.conf
	fi
else
	if [ "$(grep -c '^ssl_cipher_list=' /etc/webmin/miniserv.conf)" = "0" ]; then
		echo 'ssl_cipher_list=ECDHE-RSA-AES256-SHA384:AES256-SHA256:RC4:HIGH:+TLSv1.2:+TLSv1:!MD5:!SSLv2:SSLv3:!ADH:!aNULL:!eNULL:!NULL:!DH:!EDH:!AESGCM' >> /etc/webmin/miniserv.conf
	else
		sed -i 's/^ssl_cipher_list=.*/ssl_cipher_list=ECDHE-RSA-AES256-SHA384:AES256-SHA256:RC4:HIGH:+TLSv1.2:+TLSv1:!MD5:!SSLv2:SSLv3:!ADH:!aNULL:!eNULL:!NULL:!DH:!EDH:!AESGCM/' /etc/webmin/miniserv.conf
	fi
	if [ "$(grep -c '^no_ssl2=' /etc/webmin/miniserv.conf)" = "0" ]; then
		echo 'no_ssl2=1' >> /etc/webmin/miniserv.conf
	else
		sed -i 's/^no_ssl2=.*/no_ssl2=1/' /etc/webmin/miniserv.conf
	fi
	if [ "$(grep -c '^no_ssl3=' /etc/webmin/miniserv.conf)" = "0" ]; then
		echo 'no_ssl3=1' >> /etc/webmin/miniserv.conf
	else
		sed -i 's/^no_ssl3=.*/no_ssl3=1/' /etc/webmin/miniserv.conf
	fi
fi
if [ "$(grep -c '^ssl_honorcipherorder=' /etc/webmin/miniserv.conf)" = "0" ]; then
	echo 'ssl_honorcipherorder=1' >> /etc/webmin/miniserv.conf
else
	sed -i 's/^ssl_honorcipherorder=.*/ssl_honorcipherorder=1/' /etc/webmin/miniserv.conf
fi
# END fix for 'sessions_ssl_cipher'

###############################################################################
# BEGIN fix (8 / 28) for 'sessions_ssl_enabled'
###############################################################################
(>&2 echo "Remediating rule 8/28: 'sessions_ssl_enabled'")
if [ "$(grep -c '^ssl=' /etc/webmin/miniserv.conf)" = "0" ]; then
	echo "ssl=1" >> /etc/webmin/miniserv.conf
else
	sed -i "s/^ssl=.*/ssl=1/" /etc/webmin/miniserv.conf
fi
if [ "$(grep -c '^ssl_redirect=' /etc/webmin/miniserv.conf)" = "0" ]; then
	echo "ssl_redirect=1" >> /etc/webmin/miniserv.conf
else
	sed -i "s/^ssl_redirect=.*/ssl_redirect=1/" /etc/webmin/miniserv.conf
fi
# END fix for 'sessions_ssl_enabled'

###############################################################################
# BEGIN fix (9 / 28) for 'sessions_timeout'
###############################################################################
(>&2 echo "Remediating rule 9/28: 'sessions_timeout'")

var_webmin_sessions_timeout="15"

if [ "$(grep -c '^logouttime=' /etc/webmin/miniserv.conf)" = "0" ]; then
	echo logouttime=$var_webmin_sessions_timeout >> /etc/webmin/miniserv.conf
else
	sed -i "s/^logouttime=.*/logouttime=$var_webmin_sessions_timeout/" /etc/webmin/miniserv.conf
fi
# END fix for 'sessions_timeout'

###############################################################################
# BEGIN fix (10 / 28) for 'logs_webmin_actions_enabled'
###############################################################################
(>&2 echo "Remediating rule 10/28: 'logs_webmin_actions_enabled'")
if [ "$(grep -c '^log=' /etc/webmin/config)" = "0" ]; then
	echo "log=1" >> /etc/webmin/config
else
	sed -i "s/^log=.*/log=1/" /etc/webmin/config
fi
# END fix for 'logs_webmin_actions_enabled'

###############################################################################
# BEGIN fix (11 / 28) for 'logs_webmin_actions_perms'
###############################################################################
(>&2 echo "Remediating rule 11/28: 'logs_webmin_actions_perms'")
if [ "$(grep -c '^logperms=' /etc/webmin/config)" = "0" ]; then
	echo "logperms=640" >> /etc/webmin/config
else
	sed -i "s/^logperms=.*/logperms=640/" /etc/webmin/config
fi
# END fix for 'logs_webmin_actions_perms'

###############################################################################
# BEGIN fix (12 / 28) for 'logs_webmin_actions_cleared'
###############################################################################
(>&2 echo "Remediating rule 12/28: 'logs_webmin_actions_cleared'")
if [ "$(grep -c '^logclear=' /etc/webmin/config)" = "0" ]; then
	echo "logclear=0" >> /etc/webmin/config
else
	sed -i "s/^logclear=.*/logclear=0/" /etc/webmin/config
fi
# END fix for 'logs_webmin_actions_cleared'

###############################################################################
# BEGIN fix (13 / 28) for 'logs_webmin_requests_enabled'
###############################################################################
(>&2 echo "Remediating rule 13/28: 'logs_webmin_requests_enabled'")
if [ "$(grep -c '^log=' /etc/webmin/miniserv.conf)" = "0" ]; then
	echo "log=1" >> /etc/webmin/miniserv.conf
else
	sed -i "s/^log=.*/log=1/" /etc/webmin/miniserv.conf
fi
# END fix for 'logs_webmin_requests_enabled'

###############################################################################
# BEGIN fix (14 / 28) for 'logs_webmin_requests_perms'
###############################################################################
(>&2 echo "Remediating rule 14/28: 'logs_webmin_requests_perms'")
if [ "$(grep -c '^logperms=' /etc/webmin/miniserv.conf)" = "0" ]; then
	echo "logperms=640" >> /etc/webmin/miniserv.conf
else
	sed -i "s/^logperms=.*/logperms=640/" /etc/webmin/miniserv.conf
fi
# END fix for 'logs_webmin_requests_perms'

###############################################################################
# BEGIN fix (15 / 28) for 'logs_webmin_requests_cleared'
###############################################################################
(>&2 echo "Remediating rule 15/28: 'logs_webmin_requests_cleared'")
if [ "$(grep -c '^logclear=' /etc/webmin/miniserv.conf)" = "0" ]; then
	echo "logclear=0" >> /etc/webmin/miniserv.conf
else
	sed -i "s/^logclear=.*/logclear=0/" /etc/webmin/miniserv.conf
fi
# END fix for 'logs_webmin_requests_cleared'

###############################################################################
# BEGIN fix (16 / 28) for 'webmin_is_up_to_date'
###############################################################################
(>&2 echo "Remediating rule 16/28: 'webmin_is_up_to_date'")
# FIX FOR THIS RULE IS MISSING
# END fix for 'webmin_is_up_to_date'

###############################################################################
# BEGIN fix (17 / 28) for 'module_useradmin_accounts_home_perms'
###############################################################################
(>&2 echo "Remediating rule 17/28: 'module_useradmin_accounts_home_perms'")
if [ "$(grep -c '^homedir_perms=' /etc/webmin/useradmin/config)" = "0" ]; then
	echo "homedir_perms=0750" >> /etc/webmin/useradmin/config
else
	sed -i "s/^homedir_perms=.*/homedir_perms=0750/" /etc/webmin/useradmin/config
fi
# END fix for 'module_useradmin_accounts_home_perms'

###############################################################################
# BEGIN fix (18 / 28) for 'module_useradmin_accounts_inactive'
###############################################################################
(>&2 echo "Remediating rule 18/28: 'module_useradmin_accounts_inactive'")

var_webmin_module_useradmin_accounts_inactive="35"

if [ "$(grep -c '^default_inactive=' /etc/webmin/useradmin/config)" = "0" ]; then
	echo default_inactive=$var_webmin_module_useradmin_accounts_inactive >> /etc/webmin/useradmin/config
else
	sed -i "s/^default_inactive=.*/default_inactive=$var_webmin_module_useradmin_accounts_inactive/" /etc/webmin/useradmin/config
fi
# END fix for 'module_useradmin_accounts_inactive'

###############################################################################
# BEGIN fix (19 / 28) for 'module_useradmin_accounts_max'
###############################################################################
(>&2 echo "Remediating rule 19/28: 'module_useradmin_accounts_max'")

var_webmin_module_useradmin_accounts_max="60"

if [ "$(grep -c '^default_max=' /etc/webmin/useradmin/config)" = "0" ]; then
	echo default_max=$var_webmin_module_useradmin_accounts_max >> /etc/webmin/useradmin/config
else
	sed -i "s/^default_max=.*/default_max=$var_webmin_module_useradmin_accounts_max/" /etc/webmin/useradmin/config
fi
# END fix for 'module_useradmin_accounts_max'

###############################################################################
# BEGIN fix (20 / 28) for 'module_useradmin_accounts_min'
###############################################################################
(>&2 echo "Remediating rule 20/28: 'module_useradmin_accounts_min'")

var_webmin_module_useradmin_accounts_min="1"

if [ "$(grep -c '^default_min=' /etc/webmin/useradmin/config)" = "0" ]; then
	echo default_min=$var_webmin_module_useradmin_accounts_min >> /etc/webmin/useradmin/config
else
	sed -i "s/^default_min=.*/default_min=$var_webmin_module_useradmin_accounts_min/" /etc/webmin/useradmin/config
fi
# END fix for 'module_useradmin_accounts_min'

###############################################################################
# BEGIN fix (21 / 28) for 'module_useradmin_accounts_warn'
###############################################################################
(>&2 echo "Remediating rule 21/28: 'module_useradmin_accounts_warn'")

var_webmin_module_useradmin_accounts_warn="7"

if [ "$(grep -c '^default_warn=' /etc/webmin/useradmin/config)" = "0" ]; then
	echo default_warn=$var_webmin_module_useradmin_accounts_warn >> /etc/webmin/useradmin/config
else
	sed -i "s/^default_warn=.*/default_warn=$var_webmin_module_useradmin_accounts_warn/" /etc/webmin/useradmin/config
fi
# END fix for 'module_useradmin_accounts_warn'

###############################################################################
# BEGIN fix (22 / 28) for 'module_useradmin_accounts_password_hash'
###############################################################################
(>&2 echo "Remediating rule 22/28: 'module_useradmin_accounts_password_hash'")

var_webmin_module_useradmin_accounts_password_hash="4"

if [ "$(grep -c '^md5=' /etc/webmin/useradmin/config)" = "0" ]; then
	echo md5=$var_webmin_module_useradmin_accounts_password_hash >> /etc/webmin/useradmin/config
else
	sed -i "s/^md5=.*/md5=$var_webmin_module_useradmin_accounts_password_hash/" /etc/webmin/useradmin/config
fi
# END fix for 'module_useradmin_accounts_password_hash'

###############################################################################
# BEGIN fix (23 / 28) for 'module_useradmin_accounts_min_length'
###############################################################################
(>&2 echo "Remediating rule 23/28: 'module_useradmin_accounts_min_length'")

var_webmin_module_useradmin_accounts_min_length="14"

if [ "$(grep -c '^passwd_min=' /etc/webmin/useradmin/config)" = "0" ]; then
	echo passwd_min=$var_webmin_module_useradmin_accounts_min_length >> /etc/webmin/useradmin/config
else
	sed -i "s/^passwd_min=.*/passwd_min=$var_webmin_module_useradmin_accounts_min_length/" /etc/webmin/useradmin/config
fi
# END fix for 'module_useradmin_accounts_min_length'

###############################################################################
# BEGIN fix (24 / 28) for 'module_useradmin_accounts_char_types'
###############################################################################
(>&2 echo "Remediating rule 24/28: 'module_useradmin_accounts_char_types'")
if [ "$(grep -c '^passwd_re=' /etc/webmin/useradmin/config)" = "0" ]; then
	echo "passwd_re=^.*(?=.*[a-z])(?=.*[A-Z])(?=.*[\d])(?=.*[\W]).*$" >> /etc/webmin/useradmin/config
else
	sed -i "s/^passwd_re=.*/passwd_re=^.*(?=.*[a-z])(?=.*[A-Z])(?=.*[\\\\d])(?=.*[\\\\W]).*$/" /etc/webmin/useradmin/config
fi
# END fix for 'module_useradmin_accounts_char_types'

###############################################################################
# BEGIN fix (25 / 28) for 'module_useradmin_accounts_password_dictionary'
###############################################################################
(>&2 echo "Remediating rule 25/28: 'module_useradmin_accounts_password_dictionary'")
if [ "$(grep -c '^passwd_dict=' /etc/webmin/useradmin/config)" = "0" ]; then
	echo "passwd_dict=1" >> /etc/webmin/useradmin/config
else
	sed -i "s/^passwd_dict=.*/passwd_dict=1/" /etc/webmin/useradmin/config
fi
# END fix for 'module_useradmin_accounts_password_dictionary'

###############################################################################
# BEGIN fix (26 / 28) for 'module_useradmin_accounts_password_same'
###############################################################################
(>&2 echo "Remediating rule 26/28: 'module_useradmin_accounts_password_same'")
if [ "$(grep -c '^passwd_same=' /etc/webmin/useradmin/config)" = "0" ]; then
	echo "passwd_same=1" >> /etc/webmin/useradmin/config
else
	sed -i "s/^passwd_same=.*/passwd_same=1/" /etc/webmin/useradmin/config
fi
# END fix for 'module_useradmin_accounts_password_same'

###############################################################################
# BEGIN fix (27 / 28) for 'module_useradmin_accounts_password_masked'
###############################################################################
(>&2 echo "Remediating rule 27/28: 'module_useradmin_accounts_password_masked'")
if [ "$(grep -c '^passwd_stars=' /etc/webmin/useradmin/config)" = "0" ]; then
	echo "passwd_stars=1" >> /etc/webmin/useradmin/config
else
	sed -i "s/^passwd_stars=.*/passwd_stars=1/" /etc/webmin/useradmin/config
fi
# END fix for 'module_useradmin_accounts_password_masked'

###############################################################################
# BEGIN fix (28 / 28) for 'module_useradmin_accounts_last_login'
###############################################################################
(>&2 echo "Remediating rule 28/28: 'module_useradmin_accounts_last_login'")
if [ "$(grep -c '^last_show=' /etc/webmin/useradmin/config)" = "0" ]; then
	echo "last_show=1" >> /etc/webmin/useradmin/config
else
	sed -i "s/^last_show=.*/last_show=1/" /etc/webmin/useradmin/config
fi
# END fix for 'module_useradmin_accounts_last_login'

